--Dodge

enemies = {}
enemySpeed = 200
--Timers
createEnemyTimerMax = 0.4
createEnemyTimer = createEnemyTimerMax
  

player = {x = 25, y = 260, speed = 200, xvel = 200, yvel = 200, img = nil}

function love.load()
	levelImg = love.graphics.newImage('assets/level.png')
	player.img = love.graphics.newImage('assets/ball.png')
	backgroundImg = love.graphics.newImage('assets/background.png')
	enemyImg = love.graphics.newImage('assets/ball.png')

	spawnTimer = 1

	level = 1

	beenThereFor = 0

	title = true

	help = false

	credits = false

	game = false

	options = false

	optionsDifficulty = false

	optionsBackground = false
	
	optionsPlayer = false

	youWon = false

	isDone = false

	font1 = love.graphics.newFont('assets/font1.ttf', 125)
	font2 = love.graphics.newFont('assets/font1.ttf', 50)
end



function love.update(dt)

	levelString = 'level  '

	levelString = levelString .. tostring(level)
	
	beenThereFor = beenThereFor + 1

	escPressed = love.keyboard.isDown('escape')	
	mouseX = love.mouse.getX()
	mouseY = love.mouse.getY()
	mouseIsPressed = love.mouse.isDown('l')

	--play button
	if mouseX >= 100 and
	title == true and
	mouseX <= 210 and
	mouseY >= 200 and
	mouseY <= 240 and
	title == true and
	mouseIsPressed == true then
		player.x = 25
		player.y = 260
		title = false
		game = true
		level = 1
		supriseTime = false
	--options button
	elseif mouseX >= 100 and
	mouseX <= 300 and
	mouseY >= 250 and
	mouseY <= 290 and
	title == true and
	mouseIsPressed == true then
		beenThereFor = 0
		title = false
		options = true
	--help button
	elseif mouseX >= 100 and
	mouseX <= 210 and
	mouseY >= 300 and
	mouseY <= 340 and
	title == true and
	mouseIsPressed == true then
		title = false
		help = true
	--credits button
	elseif mouseX >= 100 and
	mouseX <= 300 and
	mouseY >= 350 and
	mouseY <= 390 and
	title == true and
	mouseIsPressed == true then
		title = false
		credits = true
	--quit button
	elseif mouseX >= 100  and
	mouseX <= 210 and
	mouseY >= 400 and
	mouseY <= 440 and
	title == true and
	mouseIsPressed == true then
		love.event.quit()
	--optionsDifficulty button
	elseif options == true and
	mouseX >= 100 and
	mouseX <= 380 and
	mouseY >= 300 and
	mouseY <= 340 and
	mouseIsPressed == true then
		options = false
		optionsDifficulty = true
	--optionsBackground button
	elseif options == true and
	mouseX >= 100 and
	mouseX <= 531 and
	mouseY >= 250 and
	mouseY <= 290 and
	beenThereFor > 50 and
	mouseIsPressed == true then
		beenThereFor = 0
		options = false
		optionsBackground = true
	--optionsPlayer button
	elseif options == true and
	mouseX >= 100 and
	mouseX <= 365 and
	mouseY >= 200 and
	mouseY <= 240 and
	beenThereFor > 50 and
	mouseIsPressed == true then
		beenThereFor = 0
		options = false
		optionsPlayer = true
	--optionsBackground black button
	elseif optionsBackground == true and
	mouseX >= 100 and
	mouseX <= 240 and
	mouseY >= 200 and
	mouseY <= 240 and
	mouseIsPressed == true then
		backgroundImg = love.graphics.newImage('assets/background.png')
	--optionsBackground red button
	elseif optionsBackground == true and
	mouseX >= 100 and
	mouseX <= 185 and
	mouseY >= 250 and
	mouseY <= 290 and
	beenThereFor > 50 and
	mouseIsPressed == true then
		backgroundImg = love.graphics.newImage('assets/background_2.png')
	--optionsBackground blue button
	elseif optionsBackground == true and
	mouseX >= 100 and
	mouseX <= 210 and
	mouseY >= 300 and
	mouseY <= 340 and
	beenThereFor > 50 and
	mouseIsPressed == true then
		backgroundImg = love.graphics.newImage('assets/background_3.png')
	--optionsBackground green button	
	elseif optionsBackground == true and
	mouseX >= 100 and
	mouseX <= 240 and
	mouseY >= 350 and
	mouseY <= 390 and
	beenThereFor > 50 and
	mouseIsPressed == true then
		backgroundImg = love.graphics.newImage('assets/background_4.png')
	--optionsBackground purple button
	elseif optionsBackground == true and
	mouseX >= 100 and
	mouseX <= 267 and
	mouseY >= 400 and
	mouseY <= 440 and
	beenThereFor > 50 and
	mouseIsPressed == true then
		backgroundImg = love.graphics.newImage('assets/background_5.png')
	--optionsBackground yellow button
	elseif optionsBackground == true and
	mouseX >= 100 and
	mouseX <= 267 and
	mouseY >= 450 and
	mouseY <= 490 and
	beenThereFor > 50 and
	mouseIsPressed == true then
		backgroundImg = love.graphics.newImage('assets/background_6.png')
	--optionsPlayer black button
	elseif optionsPlayer == true and
	mouseX >= 100 and
	mouseX <= 240 and
	mouseY >= 200 and
	mouseY <= 240 and
	mouseIsPressed == true then
		player.img = love.graphics.newImage('assets/ball.png')
	--optionsPlayer red button	
	elseif optionsPlayer == true and
	mouseX >= 100 and
	mouseX <= 185 and
	mouseY >= 250 and
	mouseY <= 290 and
	beenThereFor > 50 and
	mouseIsPressed == true then
		player.img = love.graphics.newImage('assets/ball_2.png')
	--optionsPlayer blue button
	elseif optionsPlayer == true and
	mouseX >= 100 and
	mouseX <= 210 and
	mouseY >= 300 and
	mouseY <= 340 and
	beenThereFor > 50 and
	mouseIsPressed == true then
		player.img = love.graphics.newImage('assets/ball_3.png')
	--optionsPlayer green button
	elseif optionsPlayer == true and
	mouseX >= 100 and
	mouseX <= 240 and
	mouseY >= 350 and
	mouseY <= 390 and
	beenThereFor > 50 and
	mouseIsPressed == true then
		player.img = love.graphics.newImage('assets/ball_4.png')
	--optionsPlayer purple button
	elseif optionsPlayer == true and
	mouseX >= 100 and
	mouseX <= 267 and
	mouseY >= 400 and
	mouseY <= 440 and
	beenThereFor > 50 and
	mouseIsPressed == true then
		player.img = love.graphics.newImage('assets/ball_5.png')
	--optionsPlayer yellow button
	elseif optionsPlayer == utrue and
	mouseX >= 100 and
	mouseX <= 267 and
	mouseY >= 450 and
	mouseY <= 490 and
	beenThereFor > 50 and
	mouseIsPressed == true then
		player.img = love.graphics.newImage('assets/ball_6.png')
	end
	--game controls
	if game == true and
	love.keyboard.isDown('a', 'left') == true and
	player.x >= 20 then
		player.x = player.x - player.xvel * dt
	end
	if game == true and
	love.keyboard.isDown('d', 'right') == true and
	player.x  <= 1020 then
		player.x = player.x + player.xvel * dt
	end
	if game == true and
	love.keyboard.isDown('w', 'up') == true and
	player.y >= 200 then
		player.y = player.y - player.yvel * dt
	end
	if game == true and
	love.keyboard.isDown('s', 'down') == true and
	player.y <= 340 then
		player.y = player.y + player.yvel * dt
	end
	--level code
	if game == true and
	player.x >= 1020 then
		level = level + 1
		enemies = {}
		player.x = 25
		player.y = 260
	elseif game == true and
	level == 21 and 
	player.x >= 980 then
		game = false
		youWon = true
	end
	-- Time out enemy creation
	createEnemyTimer = createEnemyTimer - (1 * dt)
	if game == true and
	createEnemyTimer < 0 then
	createEnemyTimer = createEnemyTimerMax

		-- Create an enemy
		randomNumber = math.random(200, 340)
		newEnemy = { x = 1000, y = randomNumber, img = enemyImg }
		table.insert(enemies, newEnemy)
	end
	-- update the positions of enemies
	for i, enemy in ipairs(enemies) do
		enemy.x = enemy.x - (200 * dt)

		if enemy.x < 0 then -- remove enemies when they pass off the screen
			table.remove(enemies, i)
		end
	end
	--esc button for escaping credits
	if escPressed == true and
	credits == true then
		credits = false
		title = true
	--esc button for escaping help page
	elseif escPressed == true and
	help == true then
		help = false
		title = true
	--esc button for escaping game page
	elseif escPressed == true and
	game == true then
		game = false
		title = true
	--esc button for escaping options page
	elseif escPressed == true and
	beenThereFor > 50 and
	options == true then
		options = false
		title = true
	--esc button for escaping optionsDifficulty page
	elseif escPressed == true and
	optionsDifficulty == true then
		beenThereFor = 0
		optionsDifficulty = false
		options = true
	--esc button for escaping optionsBackground page
	elseif escPressed == true and
	optionsBackground == true then
		beenThereFor = 0
		optionsBackground = false
		options = true	
	--esc button for escaping optionsPlayer page
	elseif escPressed == true and
	optionsPlayer == true then
		beenThereFor = 0
		optionsPlayer = false
		options = true
	--esc button for escaping youWon page
	elseif escPressed == true and
	youWon == true then
		beenThereFor = 0
		youWon = false
		title = true
	end
end



function love.draw()
	love.graphics.draw(backgroundImg, 0, 0)
	if title == true then
		love.graphics.setFont(font1)
		love.graphics.print('Dodge', 20, 20)
		love.graphics.setFont(font2)
		love.graphics.print('Play', 100, 200)
		love.graphics.print('Options', 100, 250)
		love.graphics.print('Help', 100, 300)
		love.graphics.print('Credits', 100, 350)
		love.graphics.print('Quit', 100, 400)
	elseif credits == true then
		love.graphics.setFont(font1)
		love.graphics.print('Credits', 20, 20)
		love.graphics.setFont(font2)
		love.graphics.print('coded  by  CanadianGamer', 75, 200)
	elseif help == true then
		love.graphics.setFont(font1)
		love.graphics.print('Help', 20, 20)
		love.graphics.setFont(font2)
		love.graphics.print('Try  not  to  die', 75, 210)
	elseif options == true then
		love.graphics.setFont(font1)
		love.graphics.print('Options', 20, 20)
		love.graphics.setFont(font2)
		love.graphics.print('player  color', 100, 200)
		love.graphics.print('background  color', 100, 250)
		love.graphics.print('difficulty', 100, 300)
	elseif optionsDifficulty == true then
		love.graphics.setFont(font1)
		love.graphics.print('Difficulty', 20, 20)
		love.graphics.setFont(font2)
		love.graphics.print('Hard', 100, 200)
		love.graphics.print('Hard', 100, 250)
		love.graphics.print('Hard', 100, 300)
	elseif optionsBackground == true then
		love.graphics.setFont(font1)
		love.graphics.print('Background', 20, 20)	
		love.graphics.setFont(font2)
		love.graphics.print('black', 100, 200)
		love.graphics.print('red', 100, 250)
		love.graphics.print('blue', 100, 300)
		love.graphics.print('green', 100, 350)
		love.graphics.print('purple', 100, 400)
		love.graphics.print('yellow', 100, 450)
	elseif optionsPlayer == true then
		love.graphics.setFont(font1)
		love.graphics.print('Player', 20, 20)	
		love.graphics.setFont(font2)
		love.graphics.print('black', 100, 200)
		love.graphics.print('red', 100, 250)
		love.graphics.print('blue', 100, 300)
		love.graphics.print('green', 100, 350)
		love.graphics.print('purple', 100, 400)
		love.graphics.print('yellow', 100, 450)	
	elseif youWon == true then
		love.graphics.setFont(font1)
		love.graphics.print('You  Won!', 20, 20)
		love.graphics.setFont(font2)
		love.graphics.print('Now  press  esc  to\ngo  back  to  title', 100, 200)
		
	elseif game == true then
		if level == 1 then
			love.graphics.draw(levelImg, 20, 200)
		end
		if level > 1 and
		level < 21 then
			love.graphics.draw(levelImg, 0, 200)
		end
		if level == 21 then
			love.graphics.draw(levelImg, -20, 200)
		end
		--enemy draw code
		for i, enemy in ipairs(enemies) do
			love.graphics.draw(enemyImg, enemy.x, enemy.y)
		end
		love.graphics.print(levelString, 20, 20)
		love.graphics.draw(player.img, player.x, player.y)
		for i, enemy in ipairs(enemies) do
		love.graphics.draw(enemy.img, enemy.x, enemy.y)
		end
	end
end